// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from microstrain_inertial_msgs:msg/MipGpsTimestamp.idl
// generated code does not contain a copyright notice

#include "microstrain_inertial_msgs/msg/detail/mip_gps_timestamp__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_microstrain_inertial_msgs
const rosidl_type_hash_t *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x57, 0x8a, 0xfd, 0x4f, 0xc1, 0xd2, 0x2d, 0xbd,
      0xa2, 0xa1, 0x1b, 0x33, 0x6d, 0xd6, 0xdb, 0x02,
      0x7d, 0xa9, 0x32, 0xbe, 0x08, 0xfd, 0xc3, 0x82,
      0x16, 0x3c, 0x57, 0x3d, 0xa2, 0xda, 0x26, 0xe3,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char microstrain_inertial_msgs__msg__MipGpsTimestamp__TYPE_NAME[] = "microstrain_inertial_msgs/msg/MipGpsTimestamp";

// Define type names, field names, and default values
static char microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__tow[] = "tow";
static char microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__week_number[] = "week_number";

static rosidl_runtime_c__type_description__Field microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELDS[] = {
  {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__tow, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELD_NAME__week_number, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {microstrain_inertial_msgs__msg__MipGpsTimestamp__TYPE_NAME, 45, 45},
      {microstrain_inertial_msgs__msg__MipGpsTimestamp__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# Definition of a GPS timestamp.\n"
  "# For more information see: https://s3.amazonaws.com/files.microstrain.com/CV7+Online/external_content/dcp/Data/shared_data/data/mip_field_shared_gps_timestamp.htm\n"
  "#   Note: This message will never be published on it's own, only included in other messages\n"
  "\n"
  "# GPS time of week (seconds)\n"
  "float64 tow\n"
  "\n"
  "# GPS Week number since 1980 (weeks)\n"
  "uint16 week_number";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {microstrain_inertial_msgs__msg__MipGpsTimestamp__TYPE_NAME, 45, 45},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 387, 387},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
microstrain_inertial_msgs__msg__MipGpsTimestamp__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *microstrain_inertial_msgs__msg__MipGpsTimestamp__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
