// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from microstrain_inertial_msgs:msg/HumanReadableStatus.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "microstrain_inertial_msgs/msg/human_readable_status.hpp"


#ifndef MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__HUMAN_READABLE_STATUS__STRUCT_HPP_
#define MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__HUMAN_READABLE_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'device_info'
#include "microstrain_inertial_msgs/msg/detail/mip_base_device_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__microstrain_inertial_msgs__msg__HumanReadableStatus __attribute__((deprecated))
#else
# define DEPRECATED__microstrain_inertial_msgs__msg__HumanReadableStatus __declspec(deprecated)
#endif

namespace microstrain_inertial_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct HumanReadableStatus_
{
  using Type = HumanReadableStatus_<ContainerAllocator>;

  explicit HumanReadableStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    device_info(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gnss_state = "";
      this->dual_antenna_fix_type = "";
      this->filter_state = "";
    }
  }

  explicit HumanReadableStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    device_info(_alloc, _init),
    gnss_state(_alloc),
    dual_antenna_fix_type(_alloc),
    filter_state(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->gnss_state = "";
      this->dual_antenna_fix_type = "";
      this->filter_state = "";
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _device_info_type =
    microstrain_inertial_msgs::msg::MipBaseDeviceInfo_<ContainerAllocator>;
  _device_info_type device_info;
  using _gnss_state_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _gnss_state_type gnss_state;
  using _dual_antenna_fix_type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _dual_antenna_fix_type_type dual_antenna_fix_type;
  using _filter_state_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _filter_state_type filter_state;
  using _status_flags_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _status_flags_type status_flags;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__device_info(
    const microstrain_inertial_msgs::msg::MipBaseDeviceInfo_<ContainerAllocator> & _arg)
  {
    this->device_info = _arg;
    return *this;
  }
  Type & set__gnss_state(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->gnss_state = _arg;
    return *this;
  }
  Type & set__dual_antenna_fix_type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->dual_antenna_fix_type = _arg;
    return *this;
  }
  Type & set__filter_state(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->filter_state = _arg;
    return *this;
  }
  Type & set__status_flags(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->status_flags = _arg;
    return *this;
  }

  // constant declarations
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> UNSUPPORTED;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GNSS_STATE_NO_FIX;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GNSS_STATE_3D_FIX;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GNSS_STATE_SBAS;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GNSS_STATE_RTK_FLOAT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> GNSS_STATE_RTK_FIXED;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> DUAL_ANTENNA_FIX_TYPE_NONE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> DUAL_ANTENNA_FIX_TYPE_FLOAT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> DUAL_ANTENNA_FIX_TYPE_FIXED;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GX5_STARTUP;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GX5_INIT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GX5_RUN_SOLUTION_VALID;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GX5_RUN_SOLUTION_ERROR;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GQ7_INIT;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GQ7_VERT_GYRO;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GQ7_AHRS;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> FILTER_STATE_GQ7_FULL_NAV;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_INIT_NO_ATTITUDE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_INIT_NO_POSITION_VELOCITY;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_IMU_UNAVAILABLE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_GPS_UNAVAILABLE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_MATRIX_SINGULARITY;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_POSITION_COVARIANCE_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_VELOCITY_COVARIANCE_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_ATTITUDE_COVARIANCE_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_NAN_IN_SOLUTION_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_GYRO_BIAS_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_ACCEL_BIAS_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_GYRO_SCALE_FACTOR_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_ACCEL_SCALE_FACTOR_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_MAG_BIAS_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_ANT_OFFSET_CORRECTION_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_MAG_HARD_IRON_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GX5_RUN_MAG_SOFT_IRON_EST_HIGH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_FILTER_CONDITION_STABLE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_FILTER_CONDITION_CONVERGING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_FILTER_CONDITION_UNSTABLE;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_ROLL_PITCH_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_HEADING_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_POSITION_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_VELOCITY_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_IMU_BIAS_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_GNSS_CLK_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_ANTENNA_LEVER_ARM_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_MOUNTING_TRANSFORM_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_TIME_SYNC_WARNING;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> STATUS_FLAGS_GQ7_SOLUTION_ERROR;

  // pointer types
  using RawPtr =
    microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__microstrain_inertial_msgs__msg__HumanReadableStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__microstrain_inertial_msgs__msg__HumanReadableStatus
    std::shared_ptr<microstrain_inertial_msgs::msg::HumanReadableStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const HumanReadableStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->device_info != other.device_info) {
      return false;
    }
    if (this->gnss_state != other.gnss_state) {
      return false;
    }
    if (this->dual_antenna_fix_type != other.dual_antenna_fix_type) {
      return false;
    }
    if (this->filter_state != other.filter_state) {
      return false;
    }
    if (this->status_flags != other.status_flags) {
      return false;
    }
    return true;
  }
  bool operator!=(const HumanReadableStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct HumanReadableStatus_

// alias to use template instance with default allocator
using HumanReadableStatus =
  microstrain_inertial_msgs::msg::HumanReadableStatus_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::UNSUPPORTED = "Unsupported";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::GNSS_STATE_NO_FIX = "No Fix";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::GNSS_STATE_3D_FIX = "3D Fix";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::GNSS_STATE_SBAS = "SBAS";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::GNSS_STATE_RTK_FLOAT = "RTK Float";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::GNSS_STATE_RTK_FIXED = "RTK Fixed";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::DUAL_ANTENNA_FIX_TYPE_NONE = "None";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::DUAL_ANTENNA_FIX_TYPE_FLOAT = "Dual Antenna Float";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::DUAL_ANTENNA_FIX_TYPE_FIXED = "Dual Antenna Fixed";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GX5_STARTUP = "Startup";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GX5_INIT = "Init";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GX5_RUN_SOLUTION_VALID = "Solution Valid";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GX5_RUN_SOLUTION_ERROR = "Solution Error";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GQ7_INIT = "Init";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GQ7_VERT_GYRO = "Vertical Gyro";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GQ7_AHRS = "AHRS";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::FILTER_STATE_GQ7_FULL_NAV = "Full Nav";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_INIT_NO_ATTITUDE = "Init No Attitude";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_INIT_NO_POSITION_VELOCITY = "Init No Position / Velocity";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_IMU_UNAVAILABLE = "IMU Unavailable";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_GPS_UNAVAILABLE = "GPS Unavailable";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_MATRIX_SINGULARITY = "Matrix Singularity";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_POSITION_COVARIANCE_WARNING = "Position Covariance Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_VELOCITY_COVARIANCE_WARNING = "Velocity Covariance Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_ATTITUDE_COVARIANCE_WARNING = "Attitude Covariance Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_NAN_IN_SOLUTION_WARNING = "NaN in Solution";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_GYRO_BIAS_EST_HIGH_WARNING = "Gyroscope Bias Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_ACCEL_BIAS_EST_HIGH_WARNING = "Accelerometer Bias Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_GYRO_SCALE_FACTOR_EST_HIGH_WARNING = "Gyroscope Scale Factor Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_ACCEL_SCALE_FACTOR_EST_HIGH_WARNING = "Accelerometer Scal Factor Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_MAG_BIAS_EST_HIGH_WARNING = "Magnetometer Bias Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_ANT_OFFSET_CORRECTION_EST_HIGH_WARNING = "Antenna Offset Correction Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_MAG_HARD_IRON_EST_HIGH_WARNING = "Magnetometer Hard Iron Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GX5_RUN_MAG_SOFT_IRON_EST_HIGH_WARNING = "Magnetometer Soft Iron Estimate High";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_FILTER_CONDITION_STABLE = "Stable";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_FILTER_CONDITION_CONVERGING = "Converging";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_FILTER_CONDITION_UNSTABLE = "Unstable";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_ROLL_PITCH_WARNING = "Roll / Pitch Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_HEADING_WARNING = "Heading Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_POSITION_WARNING = "Position Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_VELOCITY_WARNING = "Velocity Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_IMU_BIAS_WARNING = "IMU Bias Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_GNSS_CLK_WARNING = "GNSS Clock Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_ANTENNA_LEVER_ARM_WARNING = "Antenna Lever Arm Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_MOUNTING_TRANSFORM_WARNING = "Mounting Transform Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_TIME_SYNC_WARNING = "Time Sync Warning";
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
HumanReadableStatus_<ContainerAllocator>::STATUS_FLAGS_GQ7_SOLUTION_ERROR = "Solution Error";

}  // namespace msg

}  // namespace microstrain_inertial_msgs

#endif  // MICROSTRAIN_INERTIAL_MSGS__MSG__DETAIL__HUMAN_READABLE_STATUS__STRUCT_HPP_
